//
//  AKAlertView.h
//  JKAlertDialog
//
//  Created by wen on 15/10/16.
//  Copyright © 2015年 www.skyfox.org. All rights reserved.
//

#import <UIKit/UIKit.h>
typedef enum ButtonType
{
    Button_OK,
    Button_CANCEL,
    Button_OTHER
    
}ButtonType;

@class AKAlertViewItem;
typedef void(^AKAlertViewHandler)(AKAlertViewItem *item);


@interface AKAlertView : UIView
{
UIView *_coverView;
UIView *_alertView;
UILabel *_labelTitle;
UILabel *_labelmessage;

UIScrollView *_buttonScrollView;
UIScrollView *_contentScrollView;

NSMutableArray *_items;
NSString *_title;
NSString *_message;
//标题图片
UIImageView *_iconView;

UIImage *_iconImage;

}

/**
 是否是本项目的格式
 */
@property(nonatomic,assign)BOOL isOUTES;

//icon是否旋转
@property(assign,nonatomic,getter=isRotate)BOOL rotate;
//按钮宽度,如果赋值,菜单按钮宽之和,超过alert宽,菜单会滚动
@property(assign,nonatomic)CGFloat buttonWidth;
//将要显示在alert上的自定义view
@property(strong,nonatomic)UIView *contentView;
@property (assign, nonatomic) BOOL isNODisplayblackView;

- (instancetype)initWithTitle:(NSString *)title message:(NSString *)message;
- (NSInteger)addButtonWithTitle:(NSString *)title;

- (instancetype)initWithIcon:(NSString *)imageName Title:(NSString *)title
                     message:(NSString *)message;

- (void)addButton:(ButtonType)type withTitle:(NSString *)title handler:(AKAlertViewHandler)handler;
- (void)show;


- (void)dismiss;



@end

@interface AKAlertViewItem : NSObject

@property (nonatomic, copy) NSString *title;
@property (nonatomic) ButtonType type;
@property (nonatomic) NSUInteger tag;
@property (nonatomic, copy) AKAlertViewHandler action;




@end
