//
//  AKAlertView.m
//  JKAlertDialog
//
//  Created by wen on 15/10/16.
//  Copyright © 2015年 www.skyfox.org. All rights reserved.
//

#import "AKAlertView.h"

#define AlertPadding 20
#define MenuHeight 35

#define AlertHeight 210
#define AlertWidth ([UIScreen mainScreen].bounds.size.width - 60)
#define iconWH 80

#define titleFont [UIFont boldSystemFontOfSize:18]

#define messageFont [UIFont systemFontOfSize:15]
#define AKCOlORFROMRGB(rgbValue)    [UIColor colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 green:((float)((rgbValue & 0xFF00) >> 8))/255.0 blue:((float)(rgbValue & 0xFF))/255.0 alpha:1.0]

#define  titleLabelColor AKCOlORFROMRGB(0X2ECAEE)
@implementation AKAlertViewItem

@end

@implementation AKAlertView

- (instancetype)initWithTitle:(NSString *)title
                      message:(NSString *)message{
    self = [super init];
    if (self) {
        _isOUTES=NO;

        _items = [[NSMutableArray alloc] init];
        _title  = title;
        _message = message;
        [self buildViews];
    }
    return self;
}

- (instancetype)initWithIcon:(NSString *)imageName Title:(NSString *)title
                     message:(NSString *)message{
    
    self = [super init];
    if (self) {
        //wen
        _isOUTES=NO;
        _items = [[NSMutableArray alloc] init];
        _title  = title;
        _message = message;
        _iconImage = [UIImage imageNamed:imageName];
        [self buildViews];
    }
    return self;
}



-(void)buildViews{
    self.frame = [self screenBounds];
    _coverView = [[UIView alloc]initWithFrame:[self topView].bounds];
    _coverView.backgroundColor = [UIColor blackColor];
    _coverView.alpha = 0;
    _coverView.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;
//    [[self topView] performSelectorOnMainThread:@selector(addSubview:) withObject:_coverView waitUntilDone:YES];
    
    _alertView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, AlertWidth, AlertHeight)];
    _alertView.center = CGPointMake(self.frame.size.width/2, self.frame.size.height/2);
    _alertView.layer.cornerRadius = 10;
    _alertView.layer.masksToBounds = YES;
    _alertView.backgroundColor = [UIColor whiteColor];
    
    [self addSubview:_alertView];
    

//        //icon
//        if (_iconImage) {
//            _iconView = [[UIImageView alloc]initWithFrame:CGRectMake((AlertWidth-iconWH)/2, 10, iconWH, iconWH)];
//            //    _iconView.backgroundColor = [UIColor redColor];
//            _iconView.image = _iconImage;
//            [_alertView addSubview:_iconView];
//        }
//        
//        //title
//        CGFloat labelHeigh;
//        if (!_title.length) {
//            labelHeigh = 0;
//        }else{
//            labelHeigh = [self heightWithString:_title font:titleFont width:AlertWidth-2*AlertPadding];
//        }
//        
//        _labelTitle = [[UILabel alloc]initWithFrame:CGRectMake( AlertPadding, CGRectGetMaxY(_iconView.frame)+AlertPadding, AlertWidth-2*AlertPadding, labelHeigh)];
//        _labelTitle.font = titleFont;
//        _labelTitle.textColor = [UIColor blackColor];
//        _labelTitle.textAlignment = NSTextAlignmentCenter;
//        _labelTitle.numberOfLines = 0;
//        _labelTitle.text = _title;
//        _labelTitle.lineBreakMode = NSLineBreakByCharWrapping;
//        [_alertView addSubview:_labelTitle];
//        
//        //message
//        CGFloat messageHeigh;
//        if (!_message.length) {
//            messageHeigh = 0;
//        }else{
//            messageHeigh = [self heightWithString:_message font:messageFont width:AlertWidth-2*AlertPadding];
//        }
//        
//        
//        _labelmessage =  [[UILabel alloc]initWithFrame:CGRectMake(AlertPadding, _labelTitle.frame.origin.y+_labelTitle.frame.size.height, AlertWidth-2*AlertPadding, messageHeigh+2*AlertPadding)];
//        _labelmessage.font = messageFont;
//        _labelmessage.textColor = [UIColor blackColor];
//        _labelmessage.textAlignment = NSTextAlignmentCenter;
//        _labelmessage.text = _message;
//        _labelmessage.numberOfLines = 0;
//        _labelmessage.lineBreakMode = NSLineBreakByCharWrapping;
//        [_alertView addSubview:_labelmessage];
//        
//        CGSize size  = CGSizeMake(AlertWidth, CGRectGetMaxY(_labelmessage.frame));
//        
//        _alertView.bounds = CGRectMake(_alertView.bounds.origin.x, _alertView.bounds.origin.y, size.width, size.height);
//        
//        _contentScrollView = [[UIScrollView alloc]initWithFrame:CGRectZero];
//        
//        [_alertView addSubview:_contentScrollView];

   
       
        
        //title
        CGFloat labelHeigh;
        if (!_title.length) {
            labelHeigh = 0;
        }else{
            labelHeigh = [self heightWithString:_title font:titleFont width:AlertWidth-2*AlertPadding];
        }
        
        _labelTitle = [[UILabel alloc]initWithFrame:CGRectMake( AlertPadding, CGRectGetMaxY(_iconView.frame)+AlertPadding, AlertWidth-2*AlertPadding, labelHeigh)];
        _labelTitle.font = titleFont;
        _labelTitle.textColor = titleLabelColor;
        _labelTitle.textAlignment = NSTextAlignmentCenter;
        _labelTitle.numberOfLines = 0;
        _labelTitle.text = _title;
        _labelTitle.lineBreakMode = NSLineBreakByCharWrapping;
        [_alertView addSubview:_labelTitle];
    
        //message
        CGFloat messageHeigh;
        if (!_message.length) {
            messageHeigh = 0;
        }else{
            messageHeigh = [self heightWithString:_message font:messageFont width:AlertWidth-2*AlertPadding];
        }
    
    
        NSMutableAttributedString *attriStr=[[NSMutableAttributedString alloc]init];
        if (_iconImage) {
            NSTextAttachment *attch=[[NSTextAttachment alloc]init];
            attch.image=_iconImage;
            attch.bounds=CGRectMake(0, -3, 17, 17);
            NSAttributedString * iconStr=[NSAttributedString attributedStringWithAttachment:attch];
            NSAttributedString *messageAttri=[[NSAttributedString alloc]initWithString:[NSString stringWithFormat:@"  %@",_message]];
            [attriStr appendAttributedString:iconStr];
            [attriStr appendAttributedString:messageAttri];
        }
        
        _labelmessage =  [[UILabel alloc]initWithFrame:CGRectMake(AlertPadding, _labelTitle.frame.origin.y+_labelTitle.frame.size.height+25, AlertWidth-2*AlertPadding, messageHeigh+10)];
        _labelmessage.font = messageFont;
//        _labelmessage.textColor = AKCOlORFROMRGB(0Xc3c3c3);
    _labelmessage.textColor = [UIColor blackColor];

        _labelmessage.textAlignment = NSTextAlignmentCenter;
        if (_iconImage) {
            _labelmessage.attributedText = attriStr;
        }
        else{
            _labelmessage.text = _message;
        }

        _labelmessage.numberOfLines = 0;
        _labelmessage.lineBreakMode = NSLineBreakByCharWrapping;
        [_alertView addSubview:_labelmessage];
        
        CGSize size  = CGSizeMake(AlertWidth, CGRectGetMaxY(_labelmessage.frame)+60);
        CGRect frame=_labelmessage.frame;
        frame.origin.y=(size.height-MenuHeight-messageHeigh)*0.5;
        _labelmessage.frame=frame;
    
        _alertView.bounds = CGRectMake(_alertView.bounds.origin.x, _alertView.bounds.origin.y, size.width, size.height);
    
    
        _contentScrollView = [[UIScrollView alloc]initWithFrame:CGRectZero];
        
        [_alertView addSubview:_contentScrollView];
    
    
    [[UIDevice currentDevice] beginGeneratingDeviceOrientationNotifications];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(deviceOrientationDidChange:) name:UIDeviceOrientationDidChangeNotification object:nil];
    
}
- (void)dealloc
{
    [[UIDevice currentDevice] endGeneratingDeviceOrientationNotifications];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIDeviceOrientationDidChangeNotification object:nil];
}
-(void)layoutSubviews{
    _buttonScrollView.frame = CGRectMake(0, _alertView.frame.size.height-MenuHeight - 15,_alertView.frame.size.width, MenuHeight);
    _contentScrollView.frame = CGRectMake(0, _labelTitle.frame.origin.y+_labelTitle.frame.size.height, _alertView.frame.size.width, _alertView.frame.size.height-MenuHeight);
    self.contentView.frame = CGRectMake(0,0,self.contentView.frame.size.width, self.contentView.frame.size.height);
    _contentScrollView.contentSize = self.contentView.frame.size;
    
}
-(void)willMoveToSuperview:(UIView *)newSuperview
{
    [self addButtonItem];
    [_contentScrollView addSubview:self.contentView];
    [self reLayout];
}
-(void)reLayout{
    CGFloat plus;
    if (self.contentView) {
        plus = self.contentView.frame.size.height-(_alertView.frame.size.height-MenuHeight);
    }else{
        plus = _labelmessage.frame.origin.y+_labelmessage.frame.size.height -(_alertView.frame.size.height-MenuHeight);
    }
    plus = MAX(0, plus);
    CGFloat height =  MIN([self screenBounds].size.height-MenuHeight,_alertView.frame.size.height+plus);
    
    _alertView.frame = CGRectMake(_alertView.frame.origin.x, _alertView.frame.origin.y, AlertWidth, height);
    _alertView.center = self.center;
    [self setNeedsDisplay];
    [self setNeedsLayout];
}
- (CGFloat)heightWithString:(NSString*)string font:(UIFont *)font width:(CGFloat)width
{
    NSDictionary *attrs = @{NSFontAttributeName:font};
    return  [string boundingRectWithSize:CGSizeMake(width, 0) options:NSStringDrawingTruncatesLastVisibleLine | NSStringDrawingUsesLineFragmentOrigin | NSStringDrawingUsesFontLeading attributes:attrs context:nil].size.height;
}
#pragma mark - add item

- (NSInteger)addButtonWithTitle:(NSString *)title{
    AKAlertViewItem *item = [[AKAlertViewItem alloc] init];
    item.title = title;
    item.action =  ^(AKAlertViewItem *item) {
        NSLog(@"no action");
    };
    item.type = Button_OK;
    [_items addObject:item];
    return [_items indexOfObject:title];
}
- (void)addButton:(ButtonType)type withTitle:(NSString *)title handler:(AKAlertViewHandler)handler{
    AKAlertViewItem *item = [[AKAlertViewItem alloc] init];
    item.title = title;
    item.action = handler;
    item.type = type;
    [_items addObject:item];
    item.tag = [_items indexOfObject:item];
}
- (void)addButtonItem {
    _buttonScrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, _alertView.frame.size.height- MenuHeight - 10,AlertWidth, MenuHeight)];
    _buttonScrollView.bounces = NO;
    _buttonScrollView.showsHorizontalScrollIndicator = NO;
    _buttonScrollView.showsVerticalScrollIndicator =  NO;
    CGFloat  width;
    if(self.buttonWidth){
        width = self.buttonWidth;
        _buttonScrollView.contentSize = CGSizeMake(width*[_items count], MenuHeight);
    }else
    {
        width = _alertView.frame.size.width/[_items count];
    }
    [_items enumerateObjectsUsingBlock:^(AKAlertViewItem *item, NSUInteger idx, BOOL *stop) {
        UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
        
        
        
        //        button.translatesAutoresizingMaskIntoConstraints = NO;
        button.frame = CGRectMake(idx*width, 1, width, MenuHeight);
        //seperator
        button.backgroundColor = [UIColor whiteColor];
        
        button.layer.shadowColor = [[UIColor grayColor] CGColor];
        if (self.isOUTES) {
            if (item.type == Button_OK) {
                [button setTitleColor:AKCOlORFROMRGB(0Xee6c00) forState:UIControlStateNormal];
                if (idx == 1) {
                    UIImageView *line = [[UIImageView alloc] initWithFrame:CGRectMake(0,0, 1, button.frame.size.height)];
                    line.backgroundColor = AKCOlORFROMRGB(0Xdbdbdb);
                    [button addSubview:line];
                }
                
            }
            else{
                [button setTitleColor:AKCOlORFROMRGB(0Xc3c3c3) forState:UIControlStateNormal];
            }
        }
        else
        {
            [button setTitleColor:AKCOlORFROMRGB(0Xc3c3c3) forState:UIControlStateNormal];
        }

        
        
        button.layer.shadowRadius = 0.5;
        button.layer.shadowOpacity = 1;
        button.layer.shadowOffset = CGSizeZero;
        button.layer.masksToBounds = NO;
        button.tag = 90000+ idx;
        // title
        [button setTitle:item.title forState:UIControlStateNormal];
        [button setTitle:item.title forState:UIControlStateSelected];
        button.titleLabel.font = [UIFont systemFontOfSize:15];
        
        // action
        [button addTarget:self
                   action:@selector(buttonTouched:)
         forControlEvents:UIControlEventTouchUpInside];
        
        [_buttonScrollView addSubview:button];
    }];
    [_alertView addSubview:_buttonScrollView];
    
}

- (void)buttonTouched:(UIButton*)button{
    AKAlertViewItem *item = _items[button.tag-90000];
    
    [self dismiss];
    
    if (item.action) {
        item.action(item);
    }
}

#pragma mark - show and dismiss
-(UIView*)topView{
    UIWindow *window = [[UIApplication sharedApplication] keyWindow];
    return  window;
}
- (void)show {
    [self performSelectorOnMainThread:@selector(showInMainThread) withObject:nil waitUntilDone:NO];
    
}

- (void)showInMainThread{
    [UIView animateWithDuration:0.5 animations:^{
        _coverView.alpha = 0.3;
    } completion:^(BOOL finished) {
        
    }];
    
    [[self topView] addSubview:self];
    [self showAnimation];
    if (self.isRotate) {
        [self showIconViewRotate];
    }

}

- (void)dismiss {
    
   
    [self performSelectorOnMainThread:@selector(hideAnimation) withObject:nil waitUntilDone:NO];
  
}
- (void)animationDidStop:(CAAnimation *)anim finished:(BOOL)flag {
    //    [self removeFromSuperview];
}

- (void)showAnimation {
    CAKeyframeAnimation *popAnimation = [CAKeyframeAnimation animationWithKeyPath:@"transform"];
    popAnimation.duration = 0.4;
    popAnimation.values = @[[NSValue valueWithCATransform3D:CATransform3DMakeScale(0.01f, 0.01f, 1.0f)],
                            [NSValue valueWithCATransform3D:CATransform3DMakeScale(1.1f, 1.1f, 1.0f)],
                            [NSValue valueWithCATransform3D:CATransform3DMakeScale(0.9f, 0.9f, 1.0f)],
                            [NSValue valueWithCATransform3D:CATransform3DIdentity]];
    popAnimation.keyTimes = @[@0.2f, @0.5f, @0.75f, @1.0f];
    popAnimation.timingFunctions = @[[CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut],
                                     [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut],
                                     [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut]];
    [_alertView.layer addAnimation:popAnimation forKey:nil];
}

- (void)showIconViewRotate{
    CABasicAnimation* rotationAnimation;
    
    rotationAnimation = [CABasicAnimation animationWithKeyPath:@"transform.rotation.z"];
    rotationAnimation.toValue = [NSNumber numberWithFloat: M_PI * 2.0 ];
    rotationAnimation.duration = 2.f;
    rotationAnimation.cumulative = YES;
    rotationAnimation.repeatCount = MAXFLOAT;
    
    [_iconView.layer addAnimation:rotationAnimation forKey:@"rotationAnimation"];
}

- (void)hideAnimation{
    [UIView animateWithDuration:0.2 animations:^{
        _coverView.alpha = 0.0;
     
        _alertView.alpha = 0.0;
        
    } completion:^(BOOL finished) {
        
        [self removeFromSuperview];
    }];

}

#pragma mark - Handle device orientation changes
// Handle device orientation changes
- (void)deviceOrientationDidChange: (NSNotification *)notification
{
    //    UIInterfaceOrientation interfaceOrientation = [[UIApplication sharedApplication] statusBarOrientation];
    self.frame = [self screenBounds];
    //NSLog(@"self.frame%@",NSStringFromCGRect(self.frame));
    [UIView animateWithDuration:0.2f delay:0.0 options:UIViewAnimationOptionTransitionNone
                     animations:^{
                         [self reLayout];
                     }
                     completion:nil
     ];
}

- (CGRect)screenBounds
{
    CGFloat screenWidth = [UIScreen mainScreen].bounds.size.width;
    CGFloat screenHeight = [UIScreen mainScreen].bounds.size.height;
    
    // On iOS7, screen width and height doesn't automatically follow orientation
    if (floor(NSFoundationVersionNumber) <= NSFoundationVersionNumber_iOS_7_1) {
        UIInterfaceOrientation interfaceOrientation = [[UIApplication sharedApplication] statusBarOrientation];
        if (UIInterfaceOrientationIsLandscape(interfaceOrientation)) {
            CGFloat tmp = screenWidth;
            screenWidth = screenHeight;
            screenHeight = tmp;
        }
    }
    
    return CGRectMake(0, 0, screenWidth, screenHeight);
}

@end
